#include "skybox.h"
#include "texload.h"

#define GL_CLAMP_TO_EDGE                  0x812F

bool CSkyBox::LoadTextures() //ielaadeejam skybox textuuras
{
    //katrai textuurai iesleedzam GL_CLAMP_TO_EDGE, lai debesiis nebuutu diivainas liinijas
    if(!LoadTexture("skybox_negx.bmp",&Texture[0]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    
    if(!LoadTexture("skybox_posx.bmp",&Texture[1]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    
    if(!LoadTexture("skybox_negy.bmp",&Texture[2]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    
    if(!LoadTexture("skybox_posy.bmp",&Texture[3]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

    if(!LoadTexture("skybox_negz.bmp",&Texture[4]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    
    if(!LoadTexture("skybox_posz.bmp",&Texture[5]))
        return false;
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    
    return true;
}



bool CSkyBox::Draw() //ziimeejas debesis kaa 6 kvadraatus
{
    glDepthMask(GL_FALSE); //ziimeejot debesis nerakstam veertiibas Z buferii
                        //lai debesis paliktu aiz visiem citiem objektiem
    glBindTexture(GL_TEXTURE_2D,Texture[0]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(-10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(-10.0f,10.0f,10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(-10.0f,-10.0f,10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(-10.0f,-10.0f,-10.0f);
    glEnd();
    
    glBindTexture(GL_TEXTURE_2D,Texture[1]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(10.0f,10.0f,10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(10.0f,-10.0f,-10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(10.0f,-10.0f,10.0f);
    glEnd();
    
    glBindTexture(GL_TEXTURE_2D,Texture[2]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(-10.0f,-10.0f,-10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(10.0f,-10.0f,-10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(10.0f,-10.0f,10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(-10.0f,-10.0f,10.0f);
    glEnd();
    
    glBindTexture(GL_TEXTURE_2D,Texture[3]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(-10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(10.0f,10.0f,10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(-10.0f,10.0f,10.0f);
    glEnd();
    
    glBindTexture(GL_TEXTURE_2D,Texture[4]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(-10.0f,10.0f,-10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(-10.0f,-10.0f,-10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(10.0f,-10.0f,-10.0f);
    glEnd();
    
    glBindTexture(GL_TEXTURE_2D,Texture[5]);
    glBegin(GL_QUADS);
    glTexCoord2f(0.0f,0.0f); glVertex3f(-10.0f,10.0f,10.0f);
    glTexCoord2f(1.0f,0.0f); glVertex3f(10.0f,10.0f,10.0f);
    glTexCoord2f(1.0f,1.0f); glVertex3f(10.0f,-10.0f,10.0f);
    glTexCoord2f(0.0f,1.0f); glVertex3f(-10.0f,-10.0f,10.0f);
    glEnd();
    glDepthMask(GL_TRUE);//saakam atkal rakstiit veertiibas Z buferii, lai
            //atlikusii sceena rendereetos pareizi
}


    
bool CSkyBox::Delete() //atbriivojam atminju
{
    glDeleteTextures(6,Texture);
}    
